extern "C" {
#include <libavfilter/avfilter.h>
}
#include <iostream>

class Comparator
{
    public:

        Comparator(const AVCodecContext *sampleCodecContext);
        ~Comparator();
        
        void pushImageA(AVFrame *frame);
        void pushImageB(AVFrame *frame);
        void printMetrics();

    private:
        AVFilterGraph *filterGraph;
        AVFilterContext *bufferSinkPsnrCtx;
        AVFilterContext *bufferSinkSsimCtx;
        AVFilterContext *bufferImageACtx;
        AVFilterContext *bufferImageBCtx;
        AVFilterContext *psnrFilterCtx;
        AVFilterContext *ssimFilterCtx;
        AVFilterContext *splitFilterImageACtx;
        AVFilterContext *splitFilterImageBCtx;
        AVFrame *resultFrame = av_frame_alloc();
        float getMetric(AVFilterContext  *filterContext, std::string dataName);
};
